import router from './router'
import store from './store'
import NProgress from 'nprogress'
import 'nprogress/nprogress.css'
import { getCookiesName } from '@/utils/auth'

NProgress.configure({ showSpinner: false })

const whiteList = ['/login', '/home'] // 不重定向白名单
router.beforeEach((to, from, next) => {
  NProgress.start()
  if (getCookiesName()) {
    if (whiteList.indexOf(to.path) > -1) {
      if (sessionStorage.getItem('uType') === '1') {
        next({ path: '/infoManage' })
      } else {
        next({ path: '/loginedHome' })
      }
      NProgress.done()
    } else {
      if (store.getters.roles.length === 0) {
        store.dispatch('GetUserInfo').then(res => {
          if (res.success) {
            const roles = [sessionStorage.getItem('uType')]
            store.dispatch('GenerateRoutes', { roles }).then(() => {
              router.addRoutes(store.getters.addRouters)
              next({ ...to, replace: true })
            })
          }
        })
      } else {
        next()
      }
    }
  } else {
    if (whiteList.indexOf(to.path) !== -1) {
      next()
    } else {
      next('/home')
      NProgress.done()
    }
  }
})
router.afterEach(() => {
  NProgress.done() // 结束Progress
})
